package com.szyx.tcm.supervision.config;

import org.asynchttpclient.DefaultAsyncHttpClient;
import org.asynchttpclient.DefaultAsyncHttpClientConfig;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.http.client.ClientHttpRequestFactory;
import org.springframework.http.client.HttpComponentsClientHttpRequestFactory;
import org.springframework.http.client.SimpleClientHttpRequestFactory;
import org.springframework.web.client.RestTemplate;

/*******************************************************************
 * <pre></pre>
 * @文件名称： HttpConfig.java
 * @包 路  径： com.szyx.tcm.supervision.config
 * @Copyright：wy (C) 2024 *
 * @Description:
 * @Version: V1.0
 * @Author： wy
 * @Date：2024/3/7 12:10
 * @Modify：
 */

@Configuration
public class HttpConfig {

    @Bean
    public DefaultAsyncHttpClient httpClient() {
        return new DefaultAsyncHttpClient(
                new DefaultAsyncHttpClientConfig.Builder().setMaxRequestRetry(3).setConnectTimeout(1000).setFollowRedirect(false).setMaxConnections(100).setMaxConnectionsPerHost(10).build());
    }

    @Bean
    public RestTemplate restTemplate(ClientHttpRequestFactory factory) {
        RestTemplate restTemplate = new RestTemplate();
        restTemplate.setRequestFactory(factory);
        return restTemplate;
    }

    @Bean
    public ClientHttpRequestFactory clientHttpRequestFactory() {
        SimpleClientHttpRequestFactory factory = new SimpleClientHttpRequestFactory();
        factory.setReadTimeout(10000);
        factory.setConnectTimeout(15000);
        return factory;
    }


}
