package com.szyx.tcm.supervision.config;

import org.springframework.context.annotation.Configuration;
import org.springframework.web.servlet.config.annotation.InterceptorRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurer;

import javax.annotation.Resource;

/*******************************************************************
 * <pre></pre>
 * @文件名称： WebAppConfigAdapter.java
 * @包 路  径： com.szyx.tcm.supervision.config
 * @Copyright：wy (C) 2024 *
 * @Description:
 * @Version: V1.0
 * @Author： wy
 * @Date： 2024/7/26 18:05
 * @Modify：
 */
@Configuration
public class WebAppConfigAdapter implements WebMvcConfigurer {

    @Resource
    private InsuranceInterceptor insuranceInterceptor;

    @Override
    public void addInterceptors(InterceptorRegistry registry) {

        // 走代理转发的接口添加拦截器
        registry.addInterceptor(insuranceInterceptor)
                .addPathPatterns("/proxy/**");

        WebMvcConfigurer.super.addInterceptors(registry);
    }
}
