package com.szyx.tcm.supervision.enums;

import com.fiftyonetrust.common.model.pojo.ResultCode;

/**
 * <pre></pre>
 *
 * @文件名称： ResultEnum
 * @包 路 径： enums
 * @Copyright：北京数字医信科技责任有限公司 (C) 2023 *
 * @Description:
 * @Version: V1.0
 * @Author： hq
 * @Date： 2023/08/22 11:01
 * @Modify：
 */
public enum ResultEnum implements ResultCode {

    FREIGHT_SETTING_ERROR(20001, "获取二维码失败"),
    UN_LOGIN_ERROR(20002, "未登录"),
    TOKEN_EXPIRED_ERROR(20003, "登录已过期,请重新登录"),
    DOCTOR_NOT_EXIST(20004, "账号未绑定!"),
    SELECT_ERROR(20005, "查询失败"),
    VERIFY_SIGNED_ERR(20006, "验证第三方签名摘要信息signed失败"),
    RECIPE_SIGN_NO_EXIST(20007, "处方签名数据不存在"),
    YWX_SYN_SIGN(20008, "调用医网信同步待签名数据失败"),
    RECIPE_SIGN_UPDATE_ERROR(20009, "处方签名数据更新失败"),
    HOS_SIGN_INSERT_ERROR(20010, "医院签章数据插入失败"),
    RECIPE_HOSPITAL_SIGN_ERROR(20011, "处方互联网医院签章操作未找到医生已签数据"),
    PDF_DOWNLOAD_ERROR(20012, "pdf下载失败"),
    PDF_UPLOAD_ERROR(20013, "pdf上传失败"),
    RECIPE_PATIENT_NOT_EXIST(20014, "处方患者信息不存在"),
    PARAMS_ERROR(20015, "参数异常"),
    PDF_PAGES_ERROR(20016, "pdf获取页数异常"),
    UPDATE_RECIPE_ERROR(20017, "同步pdf到同仁堂失败"),
    UNIQUE_ID_NO_EXIST(20018, "回调signId参数为空"),
    SIGNED_PDF_BASE64_NO_EXIST(20019, "回调pdfBase64为空"),
    OPEN_ID_NO_EXIST(20020, "openID为空"),
    ADD_SIGN_IMAGE(20021,"添加签名图片异常"),
    ADD_STAMP_IMAGE(20022,"添加签章图片异常"),

    DECRYPT_ERROR(10055, "解密异常"),

    REPETITION_ERROR(10056, "请勿重复操作"),

    VERIFY_ERROR(10057, "鉴权失败，请检查请求头参数"),
    ;

    private final Integer code;
    private final String message;

    ResultEnum(Integer code, String message) {
        this.code = code;
        this.message = message;
    }

    @Override
    public int getCode() {
        return this.code;
    }

    @Override
    public String getMessage() {
        return this.message;
    }
}
