package com.szyx.tcm.supervision.enums;

import lombok.Getter;

/**
 * <pre></pre>
 *
 * @文件名称： WeekDayEnum
 * @包 路  径： com.szyx.tcm.common.enums
 * @Copyright：北京数字医信科技责任有限公司 (C) 2023 *
 * @Description:
 * @Version: V1.0
 * @Author： luzhenjie
 * @Date：2023/6/1 12:03
 * @Modify：
 */
@Getter
public enum WeekDayEnum {

    SUNDAY(1, "SUNDAY", "周日",7),
    MONDAY(2, "MONDAY", "周一",1),
    TUESDAY(3, "TUESDAY", "周二",2),
    WEDNESDAY(4, "WEDNESDAY", "周三",3),
    THURSDAY(5, "THURSDAY", "周四",4),
    FRIDAY(6, "FRIDAY", "周五",5),
    SATURDAY(7, "SATURDAY", "周六",6);

    private final Integer code;
    private final String name;
    private final String desc;
    //
    private final Integer index;

    WeekDayEnum(int code, String name, String desc, Integer index) {
        this.code = code;
        this.name = name;
        this.desc = desc;
        this.index = index;
    }

    public static String getByCode(Integer code) {
        for (WeekDayEnum statusEnum : WeekDayEnum.values()) {
            if (statusEnum.getCode().equals(code)) {
                return statusEnum.desc;
            }
        }
        return "";
    }

    public static String getByName(String name) {
        for (WeekDayEnum statusEnum : WeekDayEnum.values()) {
            if (statusEnum.getName().equals(name)) {
                return statusEnum.desc;
            }
        }
        return "";
    }

    public static Integer getIndexByCode(Integer code) {
        for (WeekDayEnum statusEnum : WeekDayEnum.values()) {
            if (statusEnum.getCode().equals(code)) {
                return statusEnum.index;
            }
        }
        return null;
    }
}
