package com.szyx.tcm.supervision;


import com.alibaba.fastjson.JSONObject;

import com.szyx.tcm.supervision.model.dto.insurance.DiseInfo;
import com.szyx.tcm.supervision.model.dto.insurance.FeeDetail;
import com.szyx.tcm.supervision.model.dto.insurance.InsuranceCoreOutputMessage1101;
import com.szyx.tcm.supervision.model.dto.insurance.InsuranceUploadRecipeDetailInputMessage;
import com.szyx.tcm.supervision.util.DateUtils;
import com.szyx.tcm.supervision.util.InsuranceWechatUtil;
import com.szyx.tcm.supervision.util.SZYXAccessUtil;
import com.tencent.mip.DataHandler;
import com.tencent.mip.MIPayInvoker;
import com.tencent.mip.model.DetailUploadReq;
import org.junit.jupiter.api.Test;

import java.io.IOException;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.UUID;


/*******************************************************************
 * <pre></pre>
 * @文件名称： InsuranceCoreDemo.java
 * @包 路  径： org.szyx.tcm.applet
 * @Copyright：wy (C) 2024 *
 * @Description: 河南医保局 医保核心系统调用demo
 * @Version: V1.0
 * @Author： wy
 * @Date： 2024/7/17 16:41
 * @Modify：
 */
public class InsuranceCoreDemo {

    private static final String url = "http://localhost:8097/fsi/api/rsfComIfsService/callService";

//    private static final

    private static String appSecret = "cb5405c1053da6e27ac2e6c5ea63c25b"; // 应⽤密钥
    private static String appId = "wx988658e383760cea"; // 应⽤ID
    private static String publicKey = "IYNKr8u66CDfzTkChz44e7AocWNqLTEO"; // 平台公钥
    private static String privateKey = "IYNKr8u66CDfzTkChz44e7AocWNqLTEO"; // 渠道私钥
    private static String reqUrl = "********************";

    private static String fixmedinsCode = "H41148100267"; // 定点医疗机构编码

    private static String mdtrtareaAdmvs = "411401"; // 就诊地医保区划

    private static String authCode = "AUTH410100202205241618510007210"; // 授权码





    public static void main(String[] args) throws IOException {
        //  6201、6202 签名sdk
        // 请求报文
        DataHandler dataHandler = DataHandler.newInstance(appId,appSecret,publicKey,privateKey);
        dataHandler.setVersion("2.0.1");

        MIPayInvoker miPayInvoker = MIPayInvoker.newInstance(dataHandler);
        DetailUploadReq detailUploadReq = new DetailUploadReq();




    }


    @Test
    public void test1() throws Exception {
        System.out.println("test1");


        InsuranceUploadRecipeDetailInputMessage uploadData = new InsuranceUploadRecipeDetailInputMessage();
        buildText(uploadData);



        String reqMessageForInsuranceCore = InsuranceWechatUtil
                .getReqMessageForInsuranceCore(appId, appSecret, publicKey, privateKey, JSONObject.toJSONString(uploadData));

        System.out.println(reqMessageForInsuranceCore);


    }

    @Test
    public void test2() throws Exception {
        System.out.println("test2");
        long timestamp = System.currentTimeMillis();
        System.out.println(SZYXAccessUtil.encryptTimeStamp(timestamp));
        System.out.println(SZYXAccessUtil.encryptByAES(Long.toString(timestamp)));

        System.out.println(  InsuranceWechatUtil.getMsgId("H41148100267"));
    }

    @Test
    public void test3() throws Exception {
        System.out.println("test3");



    }




    private void buildText(InsuranceUploadRecipeDetailInputMessage uploadData){

        // 医保核心系统患者基本信息
        InsuranceCoreOutputMessage1101.Baseinfo baseinfo = new InsuranceCoreOutputMessage1101.Baseinfo();
        baseinfo.setPsnNo("131000202001001");
        baseinfo.setPsnCertType("2");
        baseinfo.setCertno("510000202001010000");
        baseinfo.setPsnName("李四");
        baseinfo.setGend("1");
        baseinfo.setNaty("01");
        baseinfo.setBrdy("2020-01-01");
        baseinfo.setAge("18");


        //  医保核心系统保信息
        InsuranceCoreOutputMessage1101.Insuinfo insuinfo = new InsuranceCoreOutputMessage1101.Insuinfo();
        insuinfo.setPsnInsuRltsId("133241523001001");
        insuinfo.setBalc(new BigDecimal("5000"));
        insuinfo.setInsutype("310");
        insuinfo.setPsnType("1001");
        insuinfo.setCvlservFlag("0");
        insuinfo.setInsuplcAdmdvs("131002");
        insuinfo.setEmpName("测试单位");





        // 费用明细
        List<FeeDetail> feedetailList = new ArrayList<>();
        // 诊断或状态明细
        List<DiseInfo> diseinfoList = new ArrayList<>();


        uploadData.setOrgCodg(fixmedinsCode);
        //        uploadData.setOrgId();
        uploadData.setPsnNo(baseinfo.getPsnNo());
        uploadData.setIdType(insuinfo.getInsutype());
        uploadData.setMedOrgOrd(UUID.randomUUID().toString().replace("-", ""));
        // 电子处方流转标志  todo 目前河南省并未测试过电子处方线上医保支付
        uploadData.setRxCircFlag("0");
        uploadData.setBegntime(DateUtils.format(new Date(), DateUtils.PATTERN_DATE_TIME));
        uploadData.setIdNo(baseinfo.getCertno());
        uploadData.setUserName(baseinfo.getPsnName());
        uploadData.setIdType("01");
        uploadData.setEcToken(authCode);
        uploadData.setInsuCode(mdtrtareaAdmvs);
        uploadData.setIptOtpNo(UUID.randomUUID().toString().replace("-", ""));
        // 字典 dept
        uploadData.setDeptName("预防保健科");
        uploadData.setCaty("A01");
        uploadData.setMedType("91");
        uploadData.setFeeType("05");
        uploadData.setMedfeeSumamt(new BigDecimal("0.01"));
        //        uploadData.setAcctUsedFlag("0");
        uploadData.setDiseCodg("A01.001");
        uploadData.setDiseName("感冒");
        uploadData.setPsnSetlway("01");
        // 公立医院内容 todo   疑问点 互联网医院是否为公立医院 公立医院改革标志 如何传参
        uploadData.setChrgBchno(UUID.randomUUID().toString().replace("-", ""));
        uploadData.setDiseinfoList(diseinfoList);
        uploadData.setFeedetailList(feedetailList);

        // ========组装诊断数据========
        DiseInfo diseInfo = new DiseInfo();
        diseinfoList.add(diseInfo);
        // 西医诊断
        diseInfo.setDiagType("1");
        // todo 确认诊断排序号
        diseInfo.setDiagSrtNo(1);
        diseInfo.setDiagCode("A01.001");
        diseInfo.setDiagName("感冒");
        diseInfo.setDiagDept("预防保健科");
        diseInfo.setDiseDorNo("wy");
        diseInfo.setDiseDorName("wy");
        diseInfo.setDiagTime(DateUtils.format(new Date(), DateUtils.PATTERN_DATE_TIME));
        diseInfo.setValiFlag("1");

        //========组装费用数据========
        FeeDetail feeDetail = new FeeDetail();

        feedetailList.add(feeDetail);
        // 如果是诊疗 传问诊单号
        feeDetail.setFeedetlSn("10086");
        feeDetail.setMdtrtId(UUID.randomUUID().toString().replace("-", ""));
        feeDetail.setPsnNo(baseinfo.getPsnNo());
        feeDetail.setChrgBchno(uploadData.getChrgBchno());
        // 同一收费批次号病种编号必须一致 todo 确认 多药品多问题
        feeDetail.setDiseCodg("A01.001");
        feeDetail.setRxno("100866");
        feeDetail.setRxCircFlag("0");
        feeDetail.setFeeOcurTime(DateUtils.format(new Date(), DateUtils.PATTERN_DATE_TIME));
        // 医疗目录编码 todo 确认互联网医院处方的医疗目录编码
        feeDetail.setMedListCodg("A01.001");
        // 医药机构目录编码 todo 确认互联网医院处方的医药机构目录编码
        feeDetail.setMedinsListCodg("A01.001");
        feeDetail.setDetItemFeeSumamt(new BigDecimal("0.01"));
        feeDetail.setCnt(new BigDecimal("1"));
        feeDetail.setPric(new BigDecimal("0.01"));
        feeDetail.setBilgDeptCodg("A01.001");
        feeDetail.setBilgDeptName("预防保健科");
        feeDetail.setBilgDrCodg("wy");
        feeDetail.setBilgDrName("wy");
        feeDetail.setHospApprFlag("1");
        // todo 确认互联网医院处方的医疗类别
        feeDetail.setMedType("医疗类别");
        feeDetail.setMedListName("医疗目录名称");
        feeDetail.setMedListSpc("医疗目录规格");









    }






}
